#
# Usage:
#
#   perl ppre.pl input output stringfile
#
# writes errors to stdout (NOT STDERR!!!!!) because STDERR cannot
# be redirected properly under '95/'98 - sigh.
#
#
# my most sincere apologies in advance for how nasty this script is.
# there's a lot of legacy code syntax support in here, which can be
# removed one of these days - like all of the ;;string stuff...
#
$strmap{"seeprom"} = "seeprom_strings" ;
$strmap{"eseg"} = "seeprom_strings" ;
&str_init() ;
$dwop = ".word" ; ## avr-as GNU
&str_init() ;
open(IN,"<$ARGV[0]") || die "$ARGV[0]: $!" ;
open(OUT,">$ARGV[1]") || die "$ARGV[1]: $!" ;
open(STRINGS,">$ARGV[2]") || die "$ARGV[2]: $!" ;
if ($ARGV[3] ne "")  {
    open(IMPORTS,"<$ARGV[3]") || die "$ARGV[3]: $!" ;
    while (<IMPORTS>)  {
        s/[\r\n]+$// ;
        $imports_required{$_} = 0 ;
    }
    close(IMPORTS) ;
}

$debug = $ENV{"PPRE_DEBUG"} ;
$LIB = $ENV{"PWDEV"}."/lib" ;
print "LIB=$LIB\n" if ($debug) ;

# read library pcode definitions
&read_def_file("$LIB/pcode.def");

# read local pcode definitions
&read_def_file("pcode.def") if (-f "pcode.def");

# read project pcode definitions (later defs override earlier ones)
$base = $ARGV[0]; $base =~ s/[.][^.]*$//;
&read_def_file("$base.def") if (-f "$base.def");

sub read_def_file {
    local($deffile) = @_ ;

    $line = 0 ;
    print STDERR "reading pcode def file: $deffile\n" if ($debug) ;
    open(D,"<$deffile") || die "$0: can't open file $deffile\n" ;
    while (<D>)  {
        s/[\r\n\s]+$// ;
        s/\s+\/\/.*// ;
        ++$line;
        if (/^\s*$/i)  {
            next ;
        } elsif (/pcode_routine\s+(.*)/i)  {
            $count = $1 ;
            if (/\.equ\s*([^= \t]+)/i)  {
                $name = $1 ;
            }
            elsif (/\s*([^: \t]+)/)  {
                $name = $1 ;
            }
            else  {
                print STDERR "$deffile($line): bad pcode def entry ($_)\n" ;
                next ;
            }
            if (substr($name,0,1) ne '.')  {
                $pcode{$name} = $count ;
            }
        }
        elsif (/^(import_[^\s:]+):/)  {
            $imports_defined{$1}++ ;
        }
    }
    close(D) ;
}

$string_number = 0 ;
while (<IN>)  {
    #
    # track file name/line number info from preprocessor.
    #
    if (/^#line\s([0-9]+)\s\"([^\"]+)\"(\s([0-9]+))*/)  {   # #line directive
        $fn = $2 ;
        $fline = $1-1 ;
    }
    else  {
        $fline++ ;
    }
    $aline++ ;
    if (/^;;string\s+([^\s]+)\s+("[^"]*")[\s\r\n]*$/)  {
        #
        # legacy ;;string support - remove later...
        #
        $label = $1 ;
        $str = $2 ;
        print "Legacy string $label ($str)\n" if ($debug) ;
        &do_string($str,$label) ;
        print OUT $_ ;
        next ;
    }
    if (/^\s*[;#]/)  {              # dont bother with comments
        print OUT ;
        next ;
    }
    if ($_ eq "\$\n")  {
        $debug = 1-$debug ;
    }
    if (/^(.*):\s*export/)  {
        print OUT ".global $1\n" ;
        print OUT ;
        next ;
    }
    ($opc,$op1,$op2) = split(" ",$_,3) ;    # no null first field
    $process = 0 ;
#    print "opc=\"$opc\" op1=\"$op1\"\n" ;
    if (defined $pcode{$opc})  {
        $process = 1 ;
    }
    elsif (substr($opc,length($opc)-1,1) eq ":")  {
        if (defined $pcode{$op1})  {
            $process = 1 ;
        }
    }
    elsif ($opc eq '.dw')  {
        ($opc,$op1x) = split(/[ \t,|]+/,$op1,2) ;
        if (defined $pcode{$opc})  {
            $process = 1 ;
        }
    }
    if ($process)  {
        &preprocess($_) ;
    }
    else  {
        if (/^\s*[0-9a-z_]+\:\s*\.asci/i)  {  # .ascii or .asciz with label
            print OUT "$_" ;
            next ;
        }
        if (/^\s*\.asci/i)  {  # .ascii or .asciz with no label
            print OUT "$_" ;
            next ;
        }
        if (/^\s*([0-9a-z_]+)\:\s*\.string\s+(cseg\s|dseg\s|eseg\s)*\s*("[^"]+")/i)  {
            $label = $1 ;
            ($seg = $2) =~ s/\s+//g ;
            $str = $3 ;
            &do_string($seg.$str,$label) ;
            print OUT ";$_" ;   # keep line count right
            next ;
        }
        if (/;;string\s+([^\s]+)\s+("[^"]*")[\s\r\n]*$/)  {
            #
            # legacy ;;string support - remove later...
            #
            $label = $1 ;
            $str = $2 ;
            print "Legacy string $label ($str)\n" if ($debug) ;
            &do_string($str,$label) ;
            print OUT $_ ;
            next ;
        }
        elsif (/"/ && !/^\s*\.include/i)  {
            s/[\r\n]+$// ;
            $s = $_ ;
            $out = "" ;
            $seg = "" ;
            while ($s ne "")  {
                $token = &stronly_toke ;
#                print "$token:" ;
                if (substr($token,0,1) eq "\"")  {  # a string!
                    $out .= &do_string($seg.$token) ;
                    $seg = "" ;
                }
                elsif ($token eq " ")  {    # don't kill seg...
                    $out .= $parsed ;
                }
                elsif ($token eq ";")  {
                    $out .= ";$s" ;
                    last ;
                }
                else  {
                    if ($seg ne "")  {  # not immediately followed by string
                        $out .= $seg ;
                    }
                    $out .= $parsed ;
                }
            }
            print OUT $out,"\n" ;
        }
        elsif (/^\S+:\s*pcode_routine\s+/)  {
            print OUT ;
            s/[\r\n]//g ;
            print STRINGS ".section pcode_definitions\n" ;
            print STRINGS ".ascii \"$_\\n\"\n" ;
        }
        else  {
            #
            # track section changes.
            #
            if (/^\s*\.([cde]seg)/i)  {
                ($default_seg = $1) =~ y/A-Z/a-z/ ;
            }
            elsif (/^\s*\.section\s+([^;]+)/)  {
                ($default_seg = $1) =~ s/[\r\n]//g ;
            }
            elsif (/^\s*string_section\s+([^,]+)\s*,\s*(\S+)/)  {
                ($strmap{$1} = $2) =~ s/[\r\n]//g ;
                $_ = ";$_" ;
            }
            elsif (/^\s*\.text/)  {
                $default_seg = "text" ;
            }
            print OUT ;
        }
    }
}
print STRINGS ".section strings\n" ;
print OUT "#line $fline \"$fn\"\n";

exit($n_errors > 0 ? 1 : 0) ;

sub preprocess  {
    local($s) = @_ ;

    $s =~ s/[\r\n]+$// ;
    if ($s =~ /^\s*([a-z0-9_]+):\s*/i)  {
        $label = $1 ;
#        print "Label: $label/" ;
        $s = substr($s,length($label),999) ;
    }
    else  {
#        print "Nolabel " ;
        $label = "" ;
    }
    $op = &toke ;       # pcode opcode
    if (substr($op,0,1) eq '.')  {
        print OUT  ;
        return ;
    }
    $operand = "" ;
    $n_ops = 0 ;
    $XX = "" ;
    $in_brackets = 0 ;
    $held = "" ;
    for (;;)  {
        $token = &toke ;
        print "$token:" if ($debug) ;
        if ($in_brackets)  {
            if ($token eq "]")  {
                if ($held ne "")  {
                    $operand .= $held ;
                    $held = "" ;
                }
                $operands[$n_ops++] = $operand ;
                $operand = "" ;
                $in_brackets = 0 ;
                next ;
            }
            #
            # handle the operand fetching modifiers.
            #
            elsif ($token =~ /^word$/i)  {
                $operand .= "XX|XW|" ;
                $XX = "+XX" ;
                $held = "0)+" ;
                next ;
            }
            elsif ($token =~ /^byte$/i)  {
                $operand =~ s/XW\|//g ;
                $operand .= "XX|" ;
                $XX = "+XX" ;
                $held = "0)+" ;
                next ;
            }
            elsif ($token =~ /^swap$/i)  {
                $operand .= "XX|XS|" ;
                $XX = "+XX" ;
                $held = "0)+" ;
                next ;
            }
            else  {
                if ($held ne "")  {
                    $operand .= $held ;
                    $held = "" ;
                }
            }
        }
        elsif ($token eq "[")  {
            if ($operand ne "")  {
                &error("Garbage before \"[\"") ;
            }
            $XX = "+XX" ;
            $operand = "(XX|XW|" ;
            $in_brackets = 1 ;
            $held = "0)+" ;
            next ;
        }
        next if ($token eq " ") ;   # ignore white space
                
        if ($token eq ',' || $token eq ';' || $token eq "")  {
            if ($in_brackets)  {
                &error("Missing \"]\"") ;
            }
            if ($operand ne "")  {
                $operands[$n_ops++] = $operand ;
            }
            last if ($token ne ',') ;
            $operand = "" ;
        }
        else  {
            $operand .= $token ;
        }
    }
    if ($in_brackets)  {
        &error("Missing bracket at EOL?") ;
    }
    if ($token eq ';')  {
        $comment = $s ;
        if ($comment =~ /;string\s+([^\s]+)\s+("[^"]*")[\s\r\n]*$/)  {
            #
            # legacy ;;string support - remove later...
            #
            $lbl = $1 ;
            $ostr = $2 ;
            print "Legacy string $lbl ($ostr)\n" if ($debug) ;
            &do_string($ostr,$lbl) ;
        }
    }
    else  {
        $comment = "" ;
    }
    print "\nOperands:\n" if ($debug) ;
    ###print OUT ".extern $op\n" ;
    ###print OUT "#line $fline \"$fn\"\n";
    print OUT "$label .dw $op$XX" ;
    for ($i=0 ; $i<$n_ops ; $i++)  {
        if ($operands[$i] =~ /^([^"]+)*"/i)  {
            $strname = &do_string($operands[$i]) ;
            $operands[$i] = $strname ;
        }
        print "\t\"".$operands[$i],"\"\n" if ($debug) ;
        print OUT ',',$operands[$i]
    }
    if ($comment ne "")  {
        print OUT " ;$comment\n" ;
    }
    else  {
        print OUT "\n" ;
    }
    if ($pcode{$op} != $n_ops)  {
        &error("Opcode $op expects $pcode{$op} operand, not $n_ops!") ;
    }
}

sub toke  {
    local($ch, $i);
    $x = "" ;
    while ($s ne "")  {
        if ($s =~ /^([^;,'" \t\[\]]+)/)  {
            $x = $1 ;
        }
        else  {
            $x = substr($s,0,1) ;
            if ($x eq "\'" || $x eq "\"")  {
if (0) {
                $regex = $x."[^$x]*".$x ;
                if ($s =~ /($regex)/)  {
                    $x = $1 ;
                }
                else  {
                    &error("Unterminated string (1,$s,$regex,$x)") ;
                }
} else {
                for ($i = 1;  ;++$i) {
                    $ch = substr($s,$i,1);
                    if ($ch eq '') {
                        &error("Unterminated string") ;
                        last;
                    }
                    if ($ch eq $x) {
                        if (substr($s,$i-1,1) ne "\\") {
                            $x = substr($s,0,$i+1);
                            last;
                        }
                    }
                }
}
            }
            elsif ($x eq ' ' || $x eq "\t")  {
                if ($s =~ /^([ \t]+)/)  {
                    $x = $1 ;
                    $s = substr($s,length($x),999) ;
                    $x = "" ;
                    next ;
                }
            }
        }
        $s = substr($s,length($x),999) ;
        last ;
    }
    $x ;
}

sub stronly_toke  {
    local($ch, $i);
    $x = "" ;
    $parsed = "" ;
    while ($s ne "")  {
        if ($s =~ /^([^;'" \t\]]+)/)  {
            $x = $1 ;
        }
        else  {
            $x = substr($s,0,1) ;
            if (($x eq "\'") || ($x eq "\""))  {
if (0) {
                $regex = $x."[^$x]*".$x ;
                if ($s =~ /($regex)/)  {
                    $x = $1 ;
                }
                else  {
                    &error("Unterminated string (2,$s,$regex,$x)") ;
                }
}else {
                for ($i = 1;  ;++$i) {
                    $ch = substr($s,$i,1);
                    if ($ch eq '') {
                        &error("Unterminated string") ;
                        last;
                    }
                    if ($ch eq $x) {
                        if (substr($s,$i-1,1) ne "\\") {
                            $x = substr($s,0,$i+1);
                            last;
                        }
                    }
                }
}
            }
            elsif ($x eq ' ' || $x eq "\t")  {
                if ($s =~ /^([ \t]+)/)  {
                    $x = $1 ;
                    $parsed = substr($s,0,length($x)) ;
                    $s = substr($s,length($x),999) ;
                    $x = " " ;
                    last ;
                }
            }
        }
        $parsed = substr($s,0,length($x)) ;
        $s = substr($s,length($x),999) ;
        $x = $parsed;
        last ;
    }
    $x ;
}

sub error  {
    print "$fn($fline): ",$_[0],"\n" ;
    $n_errors++ ;
}

sub do_string  {
    local($ostr,$strname,$str,$i) = @_ ;

    if ($ostr =~ /^([^"]*)(".*)/i)  {
        $strmod = $1 ;
        if ($strmod ne "")  {
            $ostr = $2 ;
        }
        else  {
            $strmod = $default_seg ;
        }
#        print "$strmod:$ostr\n" ;
        if (defined $strmap{$strmod})  {
            print STRINGS ".section $strmap{$strmod}\n" ;
        }
        else  {
            print STRINGS ".section strings\n" ;
        }
        if ($strname eq "")  {
            $strname = sprintf("___str%04X",$string_number++) ;
        }
    }
    print "do_string($strmod$ostr) returns $strname\n" if ($debug) ;
    if (substr($ostr,0,1) eq "\"")  {
        $ostr = substr($ostr,1,length($ostr)-2) ;
    }
    else  {
        &error("Improperly coded string.") ;
        return $ostr ;
    }
    $ostr =~ s/\$\$VERSION\$\$/$version/g ;
    $str = $ostr."\0" ;        # put in the trailing NUL
    $str =~ s/\\([rnt])/$ct{$1}/eg ;
    $str =~ s/\\(['"])/$1/eg ;
    print STRINGS "$strname:\t\t; $ostr\n" ;     # label first
    for ($i=0 ; $i<length($str) ; $i+=2)  {
        printf STRINGS "\t.word 0x%04X\n",unpack("S",substr($str,$i,2)) ;
    }
    $strname ;
}

sub str_init  {
    %ct = (
        "r","\r",
        "n","\n",
        "t","\t"
    ) ;
    if (open(V,"<version"))  {
        $_ = scalar(<V>) ;
        ($version=$_) =~ s/[\r\n]+// ;
        close(V) ;
    }
}



