while (<STDIN>)  {
    if (/^\s*label\s+(.*)/)  {
        print "$1:\n" ;
        next ;
    }
    next if (/^\s*\/\//) ;
    next if (/^\s*\.device/i) ;
    next if (/^\s*\.listmac/i) ;
    if (/^\s*\.dseg/)  {
        print ".data\n" ;
        next ;
    }
    if (/^\s*\.cseg/)  {
        print ".text\n" ;
        next ;
    }
    if (/^\s*\.cseg/)  {
        print ".section seeprom\n" ;
        next ;
    }
    if (/(.*)\s*\.dw\s+(.*)/)  {
        print "${1}.word $2\n" ;
        next ;
    }
    if (/(.*)\s*\.db\s+(.*)/)  {
        print "${1}.byte $2\n" ;
        next ;
    }
    if (/^\s*\.equ\s+([^\s]+)\s*=\s*(.*)/)  {
        $equ = ".equ $1,$2\n" ;
        $equ =~ tr/[A-Z]/[a-z]/ ;
        print $equ ;
        $equ =~ tr/[a-z]/[A-Z]/ ;
        print $equ ;
        next ;
    }
    print ;
}
