open(I,">htmldoc/index.html") || die ;
print I "<html><pre>\n" ;
while (<STDIN>)  {
    if (/^;\+/)  {
        $enabled = 1 ;
        $file = "" ;
    }
    if ($enabled)  {
        if (/^;\-/)  {
            $enabled = 0 ;
            close(F) ;
            $file = "" ;
        }
        elsif (/^; \*\*-([^\-]+)\-(pcode.+)$/)  {
            $what = $1 ;
            $desc = $2 ;
            if ($file eq "")  {
                $file = "$what.html" ;
                open(F,">htmldoc/$file") || die ;
                print F "<html><pre>\n" ;
            }
            $descs{$what} = $desc.pack("C",1).$file ;
        }
        if ($enabled)  {
            s/r10/p1/gi ;
            s/r12/p2/gi ;
            s/r14/p3/gi ;
            print F ;
        }
    }
}
(@skeys) = sort (keys %descs) ;
while ($what = shift @skeys)  {
    $desc = $descs{$what} ;
    ($desc,$file) = split(pack("C",1),$desc) ;
    printf I "<a href=\"$file\">$what</a>%s$desc<br>\n",
        substr("                               ",0,16-length($what)) ;
}
