;+
; **-dumpsram-dump sram in hex.
;-
.text
	.global dump_sram
dump_sram:
	movwi z,CODEP(readb_y)
dumpx:
	ldsw    y,cmdop1
	ldsw    r21,cmdop2          ; get length
	lds     ch,putc_b
	tst     ch
	breq    dumpsr1             ; no limit if going to serial port
	cmpwi    r21,1024
	brlo    dumpsr1
	breq    dumpsr1
	movwi    r21,1024
dumpsr1:
	wdr
	mov     ch,yl
	andi    ch,0x0f
	brne    dumpsr2
	crlf
	rcall   hexy
dumpsr2:
	space
	pushw z
	icall
	popw z
	hexb
        decw r21
        brcs dumpsr_done
        brne dumpsr1
dumpsr_done:
	crlf
	ret

readb_y:
	ld i0,y+
	ret

;+
; **-dump_eeprom-dump eeprom.
;-
	.global dump_eeprom
dump_eeprom:
        movwi z,CODEP(rdeeb)
        rjmp dumpx

;+
; **-dump_seeprom-dump seeprom.
;-
	.global dump_seeprom
dump_seeprom:
        movwi z,CODEP(rdseeb)
        rjmp dumpx

